OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
roticvSSE proc lpstring:dword
		mov		eax, [esp+4]
		cmp		byte ptr[eax], 0
		mov		ecx, eax
		jz		done
		and		ecx, 0FFFFFFF8h
		add		ecx, 8
		sub		ecx, eax
		cmp		ecx, 8
		jz		aligned
	@@:
		add		eax, 1				;Simple byte scanner for alignment
		cmp		byte ptr[eax],0
		jz		done
		sub		ecx, 1
		jnz		@B
	aligned:
		pxor	mm1, mm1
		align 16
	@@:
		movq	mm0, [eax]
    	pcmpeqb	mm0,mm1
		add		eax, 8
        pmovmskb ecx,mm0
        test	ecx, ecx
        jz		@B
        bsf 	ecx, ecx
        emms
        lea		eax, [eax+ecx-8]
	done:
		sub		eax, [esp+4]
		retn 4
roticvSSE endp

align 16
roticv2 proc lpstring:dword
	;int 3
		mov		eax, [esp+4]
		cmp		byte ptr[eax], 0
		mov		ecx, eax
		jz		done
		and		ecx, 0FFFFFFE0h
		add		ecx, 16
		sub		ecx, eax
		cmp		ecx, 16
		jz		aligned
	@@:
		add		eax, 1				;Simple byte scanner for alignment
		cmp		byte ptr[eax],0
		jz		done
		sub		ecx, 1
		jnz		@B
	aligned:
		pxor	xmm1, xmm1
		align 16
	@@:
		movdqa	xmm0, [eax]
		pcmpeqb	xmm0, xmm1
		add		eax, 16
		pmovmskb ecx, xmm0
		test	ecx, ecx
		jz		@B
		bsf 	ecx, ecx
		lea		eax, [eax+ecx-16]
	done:
		sub		eax, [esp+4]
		retn 4
roticv2 endp
	
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef